/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.records.TCoreScaleRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreScale extends TableImpl<TCoreScaleRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_scale</code>
     */
    public static final TCoreScale T_CORE_SCALE = new TCoreScale();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreScaleRecord> getRecordType() {
        return TCoreScaleRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_scale.pk_core_scale</code>.
     */
    public final TableField<TCoreScaleRecord, Integer> PK_CORE_SCALE = createField(DSL.name("pk_core_scale"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_scale.scale_niveau</code>. scale niveau
     */
    public final TableField<TCoreScaleRecord, Integer> SCALE_NIVEAU = createField(DSL.name("scale_niveau"), SQLDataType.INTEGER.nullable(false), this, "scale niveau");

    /**
     * The column <code>common_dd.t_core_scale.scale_lang</code>. language key
     * of scale
     */
    public final TableField<TCoreScaleRecord, String> SCALE_LANG = createField(DSL.name("scale_lang"), SQLDataType.CLOB.nullable(false), this, "language key of scale");

    /**
     * The column <code>common_dd.t_core_scale.scale_datatype</code>. datatype
     * of scale
     */
    public final TableField<TCoreScaleRecord, String> SCALE_DATATYPE = createField(DSL.name("scale_datatype"), SQLDataType.CLOB.nullable(false), this, "datatype of scale");

    /**
     * The column <code>common_dd.t_core_scale.lastchange</code>.
     */
    public final TableField<TCoreScaleRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreScale(Name alias, Table<TCoreScaleRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreScale(Name alias, Table<TCoreScaleRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_scale</code> table reference
     */
    public TCoreScale(String alias) {
        this(DSL.name(alias), T_CORE_SCALE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_scale</code> table reference
     */
    public TCoreScale(Name alias) {
        this(alias, T_CORE_SCALE);
    }

    /**
     * Create a <code>common_dd.t_core_scale</code> table reference
     */
    public TCoreScale() {
        this(DSL.name("t_core_scale"), null);
    }

    public <O extends Record> TCoreScale(Table<O> path, ForeignKey<O, TCoreScaleRecord> childPath, InverseForeignKey<O, TCoreScaleRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_SCALE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreScalePath extends TCoreScale implements Path<TCoreScaleRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreScalePath(Table<O> path, ForeignKey<O, TCoreScaleRecord> childPath, InverseForeignKey<O, TCoreScaleRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreScalePath(Name alias, Table<TCoreScaleRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreScalePath as(String alias) {
            return new TCoreScalePath(DSL.name(alias), this);
        }

        @Override
        public TCoreScalePath as(Name alias) {
            return new TCoreScalePath(alias, this);
        }

        @Override
        public TCoreScalePath as(Table<?> alias) {
            return new TCoreScalePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreScaleRecord, Integer> getIdentity() {
        return (Identity<TCoreScaleRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreScaleRecord> getPrimaryKey() {
        return Keys.PK_CORE_SCALE;
    }

    @Override
    public List<UniqueKey<TCoreScaleRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_SCALE_NIVEAU);
    }

    @Override
    public List<ForeignKey<TCoreScaleRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_SCALE__FK_SCALE_LANG);
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_CORE_SCALE__FK_SCALE_LANG, null);

        return _tCoreTranslationKey;
    }

    @Override
    public TCoreScale as(String alias) {
        return new TCoreScale(DSL.name(alias), this);
    }

    @Override
    public TCoreScale as(Name alias) {
        return new TCoreScale(alias, this);
    }

    @Override
    public TCoreScale as(Table<?> alias) {
        return new TCoreScale(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreScale rename(String name) {
        return new TCoreScale(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreScale rename(Name name) {
        return new TCoreScale(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreScale rename(Table<?> name) {
        return new TCoreScale(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale where(Condition condition) {
        return new TCoreScale(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreScale where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreScale where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreScale where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreScale where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreScale whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
